<template>
  <v-btn
    v-if="showResults"
    :color="selectedFilters ? 'primary' : activatorColor"
    v-bind="props"
    :variant="activatorVariant"
    :prepend-icon="activatorIcon"
    :text="activatorText"
    :height="activatorHeight"
    class="!normal-case !rounded-[8px]"
    @click="emit('activator-clicked')"
  >
    <template
      v-if="selectedFilters"
      #append
    >
      <div class="w-4 h-4 flex justify-center items-center !bg-primary-lighten-3 !p-1 rounded-full">
        <p class="text-primary">
          {{ selectedFilters }}
        </p>
      </div>
    </template>
  </v-btn>

  <v-menu
    v-else
    origin="top end"
    location="bottom end"
    :close-on-content-click="true"
  >
    <template #activator="{ props }">
      <v-btn
        :color="selectedFilters ? 'primary' : activatorColor"
        v-bind="props"
        :variant="activatorVariant"
        :prepend-icon="activatorIcon"
        :text="(activatorText)"
        :height="activatorHeight"
        class="!normal-case !rounded-[8px]"
        @click="getFilterItems"
      >
        <template
          v-if="selectedFilters"
          #append
        >
          <div class="w-4 h-4 flex justify-center items-center !bg-primary-lighten-3 !p-1 rounded-full">
            <p class="text-primary">
              {{ selectedFilters }}
            </p>
          </div>
        </template>
      </v-btn>
    </template>

    <div v-if="filterItemsLoading" class="w-[200px] h-[200px] flex flex-col justify-center items-center rounded bg-white shadow-md">
      <v-progress-circular
        color="primary"
        indeterminate
        :size="32"
      />
    </div>

    <v-list v-else class="py-0 max-h-[250px]">
      <v-list-item
        v-for="(item, index) in filterItems"
        :key="item?.key"
        :value="item?.key"
        @click="addFilter(item)"
      >
        <div
          class="flex items-center gap-2 flex-1"
        >
          <!-- List item icon -->
          <div v-if="item?.icon">
            <Icon
              :icon="item?.icon"
              height="16"
              width="16"
              class="text-fakeBlack"
            />
          </div>

          <!-- List item text -->
          <p class="text-fakeBlack text-sm font-normal line-clamp-1">
            {{ item?.title }}
          </p>
        </div>
      </v-list-item>
    </v-list>
  </v-menu>
</template>

<script setup>
import { ref } from 'vue';
import { Icon } from '@iconify/vue';
import filters from '../../tools/filters.js';

const props = defineProps({
  activatorText: { type: String, default: 'Filters' },
  activatorIcon: { type: String, default: 'mdi-filter-outline' },
  activatorVariant: { type: String, default: 'outlined' },
  activatorColor: { type: String, default: 'darkGrey' },
  activatorHeight: { type: Number, default: 48 },
  filterItems: { type: Array, default: () => [
    {
      key: "campaign_type",
      title: "Type",
      icon: "icon-park-outline:down-c",
      type: "multi_select",
    },
    {
      key: "title",
      title: "Campaign title",
      icon: "mdi-format-text",
      type: "text",
    },
    {
      key: "startline",
      title: "Period",
      icon: "akar-icons:calendar",
      type: "date",
    },
    {
      key: "categories",
      title: "Tags",
      icon: "fluent:tag-32-regular",
      type: "multi_select",
    },
    {
      key: "employees_count",
      title: "Participants",
      icon: "mdi-account-outline",
      type: "number",
    },
    {
      key: "completion",
      title: "Completion",
      icon: "ic:baseline-percent",
      type: "number",
    },
  ] },
  selectedFilters: { type: Number, default: null },
  showResults: { type: Boolean, default: false },
})

const emit = defineEmits(['add-filter', 'activator-clicked'])

const filterItemsLoading = ref(true);

const getFilterItems = () => {
  setTimeout(() => {
    filterItemsLoading.value = false;
  }, 500);
}

const addFilter = (item) => {
  let newItem = { ...item, id: filters.generateUniqueId() }
  emit('add-filter', newItem)
}
</script>